/**



**/

#include <irrlicht.h>
#include <iostream>


using namespace irr;


using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;


#ifdef _IRR_WINDOWS_
#pragma comment(lib, "Irrlicht.lib")
#pragma comment(linker, "/subsystem:windows /ENTRY:mainCRTStartup")
#endif



enum {
JOYSTICK_LIST,
EVENT_LOGGER,
//JOYSTICK_AXIS_X,
//JOYSTICK_AXIS_Y,
//JOYSTICK_AXIS_U,
//JOYSTICK_AXIS_V,
JOYSTICK_BUTTONS,
THRESHOLD_SELECTOR,
THRESHOLD_TEXT,
JOYSTICKDESCRIPTOR_TEXT,
AXES_TABLE
};
/*
// TODO :
-pouvoir choisir le joystick
-valeur des axes
*/
struct MyEventReciever : public IEventReceiver
{
    IrrlichtDevice* Device;
    IGUIListBox* EventList;           //!< to log events
    IJoystick* CurrentJoystick;     //!< currentJoystick

    IGUIComboBox * JoystickList;
    ILogger* Logger;
    IGUIScrollBar * ThresholdSelector;
    IGUITable *AxesTable;
    IGUIStaticText *CapabilitiesText;
    IGUIStaticText *ThresholdText;
    IGUIStaticText *JoystickDescriptor;
    core::array<IJoystick*> Joysticks;


    MyEventReciever(IrrlichtDevice* device) :
                        Device(device),EventList(0),
                        CurrentJoystick(0),JoystickList(0),
                        AxesTable(0),ThresholdText(0),
                        Logger(0),
                        JoystickDescriptor(0)
    {
        IGUIEnvironment* guienv     = device->getGUIEnvironment();

        Logger = device->getLogger();


        /////////////////////////////////////////////////////
        ///// Add combobox to choose between available joysticks
        /////////////////////////////////////////////////////
        JoystickList = guienv->addComboBox (core::recti( 0,0,200,30),
                                0,  //!< parent
                                JOYSTICK_LIST  //!< Id
                                );


        // Should be
        ThresholdSelector = guienv->addScrollBar ( true,    //!< horizontal
                                               core::recti ( 200, 0,400,20),
                                               0,    //!< parent
                                               THRESHOLD_SELECTOR       //!< Id
                                               );
        ThresholdSelector->setMax ( 10000 );

        ThresholdText = guienv->addStaticText ( L"Threshold value" , recti(200, 20, 400, 40),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  THRESHOLD_TEXT,   //!< Id
                                                  false //!<fillBackground
                                                  );

        JoystickDescriptor = guienv->addStaticText ( L"Number of buttons: " , recti(5, 180, 200, 200),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  JOYSTICKDESCRIPTOR_TEXT,   //!< Id
                                                  false //!<fillBackground
                                                  );

        /////////////////////////////////////////////////////
        ///// Create  listbox to log events
        /////////////////////////////////////////////////////
        //EventList = guienv->addListBox(rect<s32>(50, 140, 250, 210));

        //addStaticText (const wchar_t *text, const core::rect< s32 > &rectangle, bool border=false, bool wordWrap=true, IGUIElement *parent=0, s32 id=-1, bool fillBackground=false)
        stringw desc(L"This joystick supports ");
        desc += L"0";
        desc += L" buttons";
        CapabilitiesText = guienv->addStaticText (desc.c_str() , recti(),
                                                  false, //!< Border
                                                  true, //!<wordWrap
                                                  0,        //!<parent
                                                  -1,   //!< Id
                                                  false //!<fillBackground
                                                  );





        /////////////////////////////////////////////////////
        ///// Create Table for buttons
        /////////////////////////////////////////////////////
//        IGUITable *  addTable (const core::rect< s32 > &rectangle, IGUIElement *parent=0, s32 id=-1, bool drawBackground=false)=0
        AxesTable = guienv->addTable(
                         core::recti(200,200,400,400),
                         0,      //!< Parent
                         AXES_TABLE //!< Ids
                         );

        AxesTable->addColumn(L"Axes");
        AxesTable->addColumn(L"Values");
//
//        AxesTable->addRow(EJA_AXIS_X);
//        AxesTable->addRow(EJA_AXIS_Y);
//        AxesTable->addRow(EJA_AXIS_Z);
//        AxesTable->addRow(EJA_AXIS_R);
//        AxesTable->addRow(EJA_AXIS_U);
//        AxesTable->addRow(EJA_AXIS_V);
//        AxesTable->addRow(EJA_AXIS_POVX);
//        AxesTable->addRow(EJA_AXIS_POVY);
//        AxesTable->addRow(EJA_AXIS_POV);

        #define ADD_ROW(axis)  AxesTable->addRow(EJA_AXIS_##axis); \
                            AxesTable->setCellText(EJA_AXIS_##axis,0,L###axis); \
                              AxesTable->setCellText(EJA_AXIS_##axis,1,L"0");

        // Row,Column
        ADD_ROW(X);
        ADD_ROW(Y);
        ADD_ROW(Z);
        ADD_ROW(R);
        ADD_ROW(U);
        ADD_ROW(V);
        ADD_ROW(POVX);
        ADD_ROW(POVY);
        ADD_ROW(POV);

        #undef ADD_ROW

//        core::recti pos(0,0,200,30);

//        guienv->addStaticText( L"X axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
//        guienv->addStaticText( L"Y axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
//        guienv->addStaticText( L"Z axis value:",pos,false,true,AxesTable );
//        pos += position2di(0,20);
    };






    bool activateJoysticks(){

        IInputManager *input = Device->getInputManager();

        //core::array<u8> joysticks;
        //joysticks
        if(input &&  input->activateJoysticks( ) ){

            Logger->log("Joysticks found");

//            // Add item to the list
//            for(u32 i(0); i < joysticks.size(); ++i){
//
//                //input->getJoystick( joysticks[i])->Name
//                JoystickList->addItem( L"Joystick" , (u32)joysticks[i]);
//            }


        }

        if( Joysticks.empty() ){
            return false;
        }

        //CurrentJoystick = input->getJoystick( joysticks[0] );
        changeJoystick( Joysticks[0] );
        return true;
    }




    /**

    **/
    bool changeJoystick(IJoystick* joy){


        //IJoystick* joy = Device->getInputManager()->getJoystick( newId );

        if(!joy){
            Logger->log("Could not set new joystick",ELL_WARNING);
            return false;
            // will update number of buttons and axis

        }

        CurrentJoystick = joy;

        // update axes table

        JoystickDescriptor->setText(L"Text");

        const SJoystickCapabilities& capabilities = joy->getCapabilities();
        for(u16 iAxis(0); iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

            EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>( iAxis);

            stringw value = "unsupported";
            // if axis supported by joystick
            if( capabilities.hasAxis( eAxis ) )
            {

                value = "OK";
                value += joy->getAxisValue(eAxis);
            }


            AxesTable->setCellText( eAxis,1,value.c_str() );
        }

        return true;
    }


    void updateAxesTable() {

            // Display Axis value
        const SJoystickCapabilities& capabilities = CurrentJoystick->getCapabilities();
        for(u16 iAxis(0); iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

            EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>( iAxis);

            stringw value = "unsupported";
            // if axis supported by joystick
            if( capabilities.hasAxis( eAxis ) )
            {

                //value = "OK";
                value = "";
                value += CurrentJoystick->getAxisValue(eAxis);
            }


            AxesTable->setCellText( eAxis,1,value.c_str() );
        }
    }


    void onJoystickDetection( IJoystick* joystick)
    {
        JoystickList->addItem( L"Joy (temp)" , Joysticks.size() );
        Joysticks.push_back( joystick);
    }




// Grabber/drop
    bool OnEvent(const SEvent& event){


        stringc logString;
//            (void)sprintf(logString, "Found joystick %d,  %d buttons '%s'",
//                joystickId,
//                caps.ButtonCount,
//                "unknown");
        switch ( event.EventType )
        {

            /////////////////////////////////////////////////////
            ///// Deal with joystick events
            /////////////////////////////////////////////////////
            case EET_JOYSTICK_INPUT_EVENT:


                // Joystick
                // TODO discard events from other joysticks ?
                //(u32)event.JoystickEvent.Id
                switch(event.JoystickEvent.Type){

                    case EJE_INIT:
                        logString =  "joystick initialized";
                        //logString += ;

                        //event.JoystickEvent.Joystick->Name.c_str()
                        onJoystickDetection( event.JoystickEvent.Joystick );

                        break;

                    case EJE_PLUGGED:

                        logString = "Joystick";
                        //logString += event.JoystickEvent.Id;
                        logString  += "plugged";

                        // TODO get name from CurrentJoystick->Name.c_str()
//                        JoystickList->addItem(  L"Joystick" , (u32)event.JoystickEvent.Id );
                        onJoystickDetection( event.JoystickEvent.Joystick );
                        break;


                    case EJE_UNPLUGGED:
                        logString = "Joystick ";
                        //logString += event.JoystickEvent.Id ;
                        logString += "unplugged";
                        //,);

                        //event.JoystickEvent.Joystick
//                        JoystickList->removeItem( JoystickList->getIndexForItemData (  ) );
//                        if( CurrentJoystick == event.JoystickEvent.Joystick){
//                            //
//                        }
                        break;

                    case EJE_BUTTON_PRESSED:
                        logString = "Button ";
                        logString += event.JoystickEvent.Button;
                        logString += " pressed";
                        break;

                    case EJE_BUTTON_RELEASED:
                        logString = "Button ";
                        logString += event.JoystickEvent.Button;
                        logString += " released";
                        break;

                    case EJE_POV_MOVED:
                        logString = "Pov moved";
                        break;

                    case EJE_AXIS_MOVED:
                        logString = "Axis ";
                        logString += event.JoystickEvent.MovedAxis;
                        logString += " moved. New value: ";
                        //logString += ;
                        AxesTable->setCellText( event.JoystickEvent.MovedAxis,
                                               1,
                                               L"temp"
                                            );
                        break;

                    default:
                        break;

                };
                break;

            case EET_GUI_EVENT:
                //IGUIElement* caller

                switch (event.GUIEvent.EventType)
                {
                    // Threshold changes
                    case EGET_SCROLL_BAR_CHANGED :
                        {
                            s32 value = static_cast<IGUIScrollBar*>( event.GUIEvent.Caller)->getPos();

//                            std::cout << "Scrollbar change";
                            logString = "New threshold value ";
                            logString += value;



                            if(CurrentJoystick){

                                CurrentJoystick->setThreshold( value );

                                stringw desc(L"Threshold value: ");
                                desc += CurrentJoystick->Threshold;



                                ThresholdText->setText( desc.c_str() );
                            }
                        }
                        break;

                    /// The selection in a combo box has been changed.
                    case EGET_COMBO_BOX_CHANGED:
                        logString = "New joystick selected";
                        break;

                    default:
                        break;
                }


            default:
                break;
        };

        if( logString.size() >0 ){
        //logger->addItem()
//            logString.append("\n");
            Logger->log( logString.c_str() , ELL_INFORMATION);
            return true;    //!< Absorb event
        }
        return false;

    };


};



/*
This is the main method. We can now use main() on every platform.
*/
int main()
{

	IrrlichtDevice *device =
		createDevice( video::EDT_SOFTWARE, dimension2d<u32>(640, 480), 16,
			false, false, false, 0);

	if (!device)
		return 1;

	device->setWindowCaption(L"Hello World! - Improved Input Demo");








	IVideoDriver* driver        = device->getVideoDriver();
	ISceneManager* smgr         = device->getSceneManager();
	IGUIEnvironment* guienv     = device->getGUIEnvironment();
	IInputManager* input        = device->getInputManager();
    ILogger* logger             = device->getLogger();
    IJoystick* joystick0 = 0;



    MyEventReciever myReceiver( device );
    device->setEventReceiver( &myReceiver );
//	guienv->addStaticText(L"Hello World! This is the Irrlicht Software renderer!",
//		rect<s32>(10,10,260,22), true);


	smgr->addCameraSceneNode(0, vector3df(0,30,-40), vector3df(0,5,0));



    if( !myReceiver.activateJoysticks() ){

        logger->log("No joystick could be retrieved",ELL_WARNING);
        device->closeDevice();
        return 0;
    }



    //int res = device->getJoysticks(Joysticks);
    joystick0 =  myReceiver.CurrentJoystick;


// TODO could be removed
    if(!joystick0){
        logger->log("No joystick retrieved",ELL_ERROR);
        return 0;
    }
    else {
        logger->log("At least one joystick retrieved");
        //joystick0 = Joysticks[0];
    }


    //sprintf()
    SJoystickCapabilities caps = joystick0->getCapabilities();
		char logString[256];
		(void)sprintf(logString, "Found joystick %d,  %d buttons '%s'",
			0,
			caps.ButtonCount,
			joystick0->Name.c_str()
			);

    logger->log(logString);



//    for(u16 i(0);i < SJoystickCapabilities::MAX_BUTTONS_NUMBER;++i){
//        table->addColumn(L"b");
//        table->setColumnWidth (i,20);
//    }

    //table->addRow(0);





    // Set threshold


    ITexture* greenButton = driver->getTexture("green_button.png");
    ITexture* redButton = driver->getTexture("red_button.png");
	while(device->run())
	{

        core::position2di destPos(10,200);
        ITexture* currentTexture = 0;

        //draw2DImage (const video::ITexture *texture, const core::position2d< s32 > &destPos)=0

		driver->beginScene(true, true, SColor(255,100,101,140));

		smgr->drawAll();
		guienv->drawAll();

        myReceiver.updateAxesTable();


        //for(u16 i(0);i < SJoystickCapabilities::MAX_BUTTONS_NUMBER; ++i){
        for(u16 i(0);i < joystick0->getCapabilities().ButtonCount; ++i){

    //        table->addColumn(L"b");
    //        table->setColumnWidth (i,20);
            if( joystick0->isButtonPressed(i) ){
                currentTexture = greenButton;
            }
            else {
                currentTexture = redButton;
            }

            driver->draw2DImage ( currentTexture, destPos);
            //destPos.X += 20;
            destPos.Y += currentTexture->getSize().Height;
        }

#if 0
        //
        SColor bgColor(0,255,0,0);
        SColor fgColor(0,0,255,0);
        //core::recti pos(300,100,600,600);
        core::recti bgRect(150,300,300,320);

        for(u16 iAxis(0);iAxis < EJA_NUMBER_OF_AXES; ++iAxis){

    //        table->addColumn(L"b");
    //        table->setColumnWidth (i,20);
            EJOYSTICK_AXIS eAxis = static_cast<EJOYSTICK_AXIS>(iAxis);
            if( joystick0->getCapabilities().hasAxis( eAxis ) ){

                // draws background, same for every axe
                //driver->draw2DRectangle (bgColor, const core::rect< s32 > &pos, const core::rect< s32 > *clip=0);
                driver->draw2DRectangle (bgColor, bgRect);

                //joystick0->getState().getAxisValue(eAxis);
                driver->draw2DRectangle (fgColor, const core::rect< s32 > &pos, const core::rect< s32 > *clip=0);
            }
            core::recti bgRect(150,300,300,320);
// Dessiner 2 rectangles l'un sur l'autre
//draw2DRectangle (SColor color, const core::rect< s32 > &pos, const core::rect< s32 > *clip=0


            //destPos.X += 20;
            destPos.Y += currentTexture->getSize().Height;
        }
#endif
		driver->endScene();
	}

	device->drop();

	return 0;
}

/*
That's it. Compile and run.
**/
